##
##  rie.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         rie
Summary:      Parser Generator for ECLR-attributed grammars
URL:          http://www.is.titech.ac.jp/~sassa/lab/rie-e.html
Vendor:       M. Sassa
Packager:     The OpenPKG Project
Distribution: OpenPKG [PLUS]
Group:        Compiler
License:      GPL
Version:      1.0.6
Release:      20020821

#   list of sources
Source0:      ftp://ftp.is.titech.ac.jp/pub/Rie/rie-%{version}.tar.gz

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20020206
PreReq:       OpenPKG, openpkg >= 20020206
AutoReq:      no
AutoReqProv:  no

%description
     Rie is a compiler generator based on attribute grammars. The class
     of attribute grammars for which attributes can be evaluated in a
     single pass during parsing without making a parse tree is called
     one-pass attribute grammars. This class is worth attention since
     most modern programming languages are now designed using the
     one-pass processing techniques. Among one-pass attribute grammars,
     LR-attributed grammar, which is the class of attribute grammars
     for which attributes can be evaluated during LR parsing, can be
     regarded as one of the largest classes concerning translation
     power. Rie is based on a variant of LR-attributed grammar where
     optimization of attribute evaluation is achieved by introducing a
     kind of equivalence relation among inherited attributes. This class
     is called ECLR-attributed grammar, where EC stands for equivalence
     class.

%prep
    %setup -q
    chmod u+w src/Makefile.in
    %{l_shtool} subst -e 's;/share;/share/rie;' src/Makefile.in

%build
    cd src
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    ./configure \
        --prefix=%{l_prefix}
    %{l_make} %{l_mflags -O}

%install
    rm -rf $RPM_BUILD_ROOT
    ( cd src
      %{l_make} %{l_mflags} install \
           prefix=$RPM_BUILD_ROOT%{l_prefix} \
           exec_prefix=$RPM_BUILD_ROOT%{l_prefix}
    )
    %{l_shtool} install -c -m 644 \
        rie-doc/rie-manual.ps $RPM_BUILD_ROOT%{l_prefix}/share/rie/
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* >/dev/null 2>&1 || true
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

